%   chaleur06.m
%   fd, 5 decembre 2010, 06, 07 mars 2025  
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
   clear ; format long

fprintf('chaleur06 \n') ; 
fprintf('equation de la chaleur avec des differences finies \n') 
fprintf('schema implicite en temps \n')


hold off 

njobs = 3  %%%  nombre de jobs 


ndf  = 128 , nitdf  = 100     
dxdf = 1/ndf ; 


%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
for kjob = 1:njobs ; %%%  boucle sur les differents jobs 

kjob
if (kjob==1); sigma = 1, end 
if (kjob==2); sigma = 10, end 
if (kjob==3); sigma = 100, end 

xxdf = zeros(1,ndf+1) ; yydf = xxdf ;  y1df = xxdf ;  yex  = xxdf ; 
xa    = 0 ; 
for j = 1:ndf+1 ; xxdf(j) = xa ; y1df(j) =  sin(pi*xa)  ; 
xa = xa + dxdf ; end 

if kjob==1 ; 
axis ([ -.02 , 1.02 , -.05 , 1.05 ]) ;
plot (xxdf,y1df,'k;;' ) 
axis ([ -.02 , 1.02 , -.05 , 1.05 ]) ;
pause (.5) 
end 

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%     boucle en temps 
 
dtdf  = sigma * dxdf**2                %  pas de temps         


uu = zeros (ndf-1,1) ; vv = uu ; 

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%%%%%%%%%%%%%%%%%       matrice 
A = zeros (ndf-1,ndf-1) ;
for j=1:ndf-1 ; A(j,j) = 1+2*sigma ; end 
for j=1:ndf-2 ; A(j,j+1) = - sigma ; end 
for j=2:ndf-1 ; A(j,j-1) = - sigma ; end 
A ; 
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

for iter = 1:nitdf

for j=1:ndf-1 ;  yydf(j+1) = uu(j) ;   end 

%%%%%   jmaj = 1  ;  its10 = floor(iter/jmaj); 
%%%%%   if (jmaj*its10==iter)
%%%%%   plot ( xxdf,y1df,'r;inf;' ,   xxdf,yydf,'b*;t;' ) 
%%%%%   pause  (.5)
%%%%%   end 


%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%%%%%%%%%%%%%%%%%       second membre  
sm = zeros (ndf-1,1) ;

for j=1:ndf-1 ; 
sm(j) =  uu(j) +  sigma * y1df(j+1) * (pi*dxdf)**2 ;
end 

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%%%%%%%%%%%%%%%%%       resolution du systeme lineaire   
vv = A \ sm ; uu=vv ;

end    %%%%%%%%       fin de la boucle en temps

yyt = zeros (ndf+1,1) ; 
for j=2:ndf ; yyt(j) = vv(j-1) ; end
yyt ; 

if (kjob==1) ; 
plot (xxdf,y1df,'k;;' , xxdf,yyt,'-*r;;') 
axis ([ -.02 , 1.02 , -.05 , 1.05 ]) ;
title ('schema implicite ; 100 iterations, sigma = 1') ;
print('06a-schema-implicite' , '-djpg','-S891,630'); end ;

hold off 
if kjob==2 ; 
plot (xxdf,y1df,'k;;' , xxdf,yyt,'-*r;;') 
axis ([ -.02 , 1.02 , -.05 , 1.05 ]) ;
title ('schema implicite ; 100 iterations, sigma = 10') ;
print('06b-schema-implicite' , '-djpg','-S891,630'); end ;

if kjob==3 ; 
plot (xxdf,y1df,'k;;' , xxdf,yyt,'-*r;;') 
axis ([ -.02 , 1.02 , -.05 , 1.05 ]) ;
title ('schema implicite ; 100 iterations, sigma = 100') ;
print('06c-schema-implicite' , '-djpg','-S891,630'); end 
%%% delete (findobj ("tag", "legend")) ; end 
pause  (.5)

end  %%%%%%%%       fin de la boucle sur les jobs 

hold off 
